#!/bin/perl

use List::Util qw(min max);

binmode STDOUT;

print pack 'a*LSSLLSSSS',
	'BM',   # file format
	12314,  # file size
	0,      # reserved
	0,      # reserved
	26,     # data offset
	12,     # DIB header size
	256,    # width
	16,     # height
	1,      # color planes
	24;     # bits per pixel

for my $g (reverse 0..15) {
	for my $b (0..15) {
		for my $r (0..15) {
			# if ($r == 0 && $g == 2 && $b == 1) {
				# print pack 'ccc', 0, 170, 17;
				# next;
			# }
			# print pack 'ccc', 17*$b, 17*$g, 17*$r; next;
			my $d = min($b, 15-$b, $r);
			print pack 'ccc',
				17*min(15, $b+$d),
				17*$g,
				17*($r-$d);
		}
	}
}
